::**********************************************************************
:: AUTOEXEC.BAT for MPEG/CD-Player
:: (C) 1998-05-15 by Klaus Peichl
::**********************************************************************

REM Remove this line for debugging:
 ECHO OFF


::----------------------------------------------------------------------
:: Set some global configuration environment variables:
:: Use the /E-switch of the SHELL-command in CONFIG.SYS to allocate
:: enough space for the environment!
:: BootDrive:
::   If you are booting from a floppy disk, change this to A:
:: WorkPath:
::  It is recommended that WorkPath points to a RAM-disk. If your
::  system is booting from drive C: and this is the only DOS-partition
::  on the device, then the RAM-disk will normally become drive D:
:: LCD:
::  Select the parallel port to which your LCD is connected and
::  adjust the /W switch to the speed of your system
::  example:  SET LCD=LCDECHO /LPT2 /W500
::----------------------------------------------------------------------

SET BootDrive=C:
SET WorkDrive=D:
SET WorkPath=%WorkDrive%\
SET PathFile=%WorkPath%Path.txt
SET NameFile=%WorkPath%Name.txt
SET LCD=LCDECHO
SET PATH=%WorkPath%;%BootDrive%\UTILITY;%BootDrive%\DOS
SET COMSPEC=%WorkPath%COMMAND.COM



::----------------------------------------------------------------------
:: Hardware Initializations:
::----------------------------------------------------------------------

:: Initialize LCD:
control\%LCD% /i

:: Load CDROM-extensions. Make shure the name behind /D: is the same 
:: as in CONFIG.SYS!
:: /L: selects the drive letter for MSCDEX.EXE. I chose R for Read-Only. 
:: If you change the drive letter, you will also have to modify
:: \CONTROL\MCP.BAT.
:: (LH is always optional but saves conventional memory)
LH %BootDrive%\DOS\MSCDEX.EXE /D:CD001 /S /L:R /M:4 /V

:: You can use SHSUCDX.EXE as a substitute for MSCDEX.EXE:
rem LH %BootDrive%\INIT\SHSUCDX.EXE /D:CD001,R


:: Initialize Sound Card:
:: I cannot help you much in this section. The following lines are
:: just an example, that will probably not work for your card.
REM Miro PCM10-setup:
 rem SET SOUND16=%BootDrive%\Special\
 rem %BootDrive%\Special\sndinit /b /NOSOUND
 rem SET BLASTER=A220 I5 D1 H5 T4


::----------------------------------------------------------------------
:: Start some utilities:
::----------------------------------------------------------------------

:: Start Drive-Chache. If you've got plenty of RAM, increase the size
:: (first number, second number is for Windows)
LH SMARTDRV.EXE 1024 1024

REM National keyboard driver:
rem LH keyb gr

rem LH doskey
rem prompt $p$g

:: Enable power-saving when idle and CPU optimization:
:: (DOSIDLE is a nice tool written by Marton Balog)
:: You can put DOSIDLE into the CONTROL-directory and
:: uncomment the following line and all calls of DOSIDLE in MCP.BAT
rem %BootDrive%\control\dosidle -cpu

:: Avoid "Abort,Retry,Fail"-Prompt in case of a read error.
:: Automatically choose Ignore:
%BootDrive%\INIT\SysError /Q I


::----------------------------------------------------------------------
:: Copy software to the Ramdisk and launch the "Master Control Program":
::----------------------------------------------------------------------

copy %BootDrive%\command.com %WorkPath%
copy %BootDrive%\control\*.* %WorkPath%
copy %BootDrive%\decoder\*.* %WorkPath%
%WorkDrive%
%WorkPath%MCP.BAT
