REM  ***************************************************
REM  ***  AUDIOCD.BAT Subprogram for MPEG/CD-Player  ***
REM  ***  (c) 1998-05-15 by Klaus Peichl             ***
REM  ***************************************************

REM  Determine number of tracks:

BEEP 2000 > NUL
SET Track=001
BEEP 0 > NUL
CDROM GetFirst
call GetError TrackMin
CDROM GetLast
call GetError TrackMax


:ShowKeys
  %LCD% /Adr64 /F CDBROWSE.LCD > NUL


REM  In the following loop, the track to play can be selected:

:CDLoop
  %LCD% /Adr0 Audio-Track%Track%%TrackMax% > NUL
  %LCD% /Adr16 of>NUL

  :KeyLoop
    BEEP 0 > NUL
    SET oldKey=%lastKey%
    SET lastKey=%Key%
    %WorkPath%GetPort /K > NUL
    call %WorkPath%GetError Key
    IF %Key%==000 GOTO KeyLoop
    IF %Key%==%lastKey% GOTO KeyDelay
  :DoKey
    %WorkPath%GetPort /K > NUL
    IF ErrorLevel 1 GOTO DoKey2
    GOTO KeyLoop
  :DoKey2
    IF %Key%==016 GOTO End
    IF %Key%==008 GOTO Shuffle
    IF %Key%==004 GOTO Previous
    IF %Key%==002 GOTO Next
    IF %Key%==001 GOTO Play
    GOTO KeyLoop
  :KeyDelay
    REM  Key Repeat Rate:
    %WorkPath%Delay 0.05
    IF %Key%==%oldKey% GOTO DoKey
    REM  Delay for Key Repeat:
    %WorkPath%Delay 0.5
    GOTO DoKey

  :Next
    BEEP 2000 > NUL
    SetError %Track%+1 %TrackMin% %TrackMax%
    call GetError Track
    BEEP 0 > NUL
    GOTO CDLoop

  :Previous
    BEEP 2000 > NUL
    SetError %Track%-1 %TrackMin% %TrackMax%
    call GetError Track
    BEEP 0 > NUL
    GOTO CDLoop

  :Shuffle
    SET Shuffle=ON
    Beep 1000 > NUL
    call InitShuf %TrackMin% %TrackMax% %WorkPath%Shuflist.txt
    BEEP 0 > NUL
  :Shuffle2
    Shuffle %WorkPath%Shuflist.txt
    call GetError Track
    GOTO Play1


REM  A second loop polls the keypad status during CD playback,
REM  updates the display and issues commands:

:Play
  SET SHUFFLE=OFF
  BEEP 2000 > NUL
  :Play1
    %LCD% /Adr64 /F CDPLAY.LCD> NUL
    BEEP 0 > NUL
    REM The below line is only needed for 20-culoumn-LCDs:
    %LCD% /Adr16 m:s>NUL
    CDROM Play %Track%
    REM Wait until keys have been released:
    GetPort /K /R0-0 > NUL
  :Play2
    CDROM Info > CDTRACK.LCD
    %LCD% /Adr0 /F CDTRACK.LCD > NUL
    GetPort /K > NUL
    IF ErrorLevel 16 GOTO End
    IF ErrorLevel  8 GOTO Pause
    IF ErrorLevel  4 GOTO Rewind
    IF ErrorLevel  2 GOTO FF
    IF ErrorLevel  1 GOTO Stop
    CDROM Status
    IF ErrorLevel  2 GOTO TrackFinished
    Goto Play2

  :TrackFinished
    BEEP 2000 > NUL
    IF %CONTPLAY%==OFF GOTO Stop
    IF %SHUFFLE%==ON GOTO Shuffle2
    SetError %Track%+1 %TrackMin% %TrackMax%
    call GetError Track
    Goto Play

  :Pause
    BEEP 2000 > NUL
    %LCD% /Adr64 /F Cont.lcd > NUL
    BEEP 0 > NUL
    CDROM Stop
    REM Wait until keys have been released:
    GetPort /K /R0-0  > NUL
    GetPort /K /R1-31 > NUL
    IF ErrorLevel 32 GOTO End
    BEEP 2000 > NUL
    %LCD% /Adr64 /F CDPLAY.LCD > NUL
    BEEP 0 > NUL
    CDROM Continue
    GetPort /K /R0-0  > NUL
    GOTO Play2

  :Stop
    BEEP 2000 > NUL
    %LCD% /M /Adr0 /F Stopping.lcd > NUL
    BEEP 0 > NUL
    CDROM Stop
    GOTO ShowKeys

  :FF
    BEEP 2000 > NUL
    %LCD% /Adr64 /F CDSEEK.LCD > NUL
    BEEP 0 > NUL
    CDROM Play +
    GOTO PlayRet

  :Rewind
    BEEP 2000 > NUL
    %LCD% /Adr64 /F CDSEEK.LCD > NUL
    BEEP 0 > NUL
    CDROM Play -

  :PlayRet
    %LCD% /Adr64 /F CDPLAY.LCD > NUL
    GOTO Play2


:Error
  %LCD% /Adr0  Error in file > NUL
  %LCD% /Adr64 AUDIOCD.BAT! > NUL
  ECHO Error in AUDIOCD.BAT!
  DELAY 1

:End
