REM  ***************************************************
REM  ***  Master Control Program for MPEG/CD-Player  ***
REM  ***  (c) 1998-05-15 by Klaus Peichl             ***
REM  ***************************************************

ECHO OFF
BREAK OFF

REM  Default value in the "DRIVE"-Menu (67=C, 68=D, ...)
SET  DRIVE=67

CALL %BootDrive%\Init\Options.bat
Next *.MP? > %WorkPath%ZEILE.LCD
IF %AUTOOFF%==OFF GOTO AutoDetect
%BootDrive%\Init\DISKOFF PM


REM --------------------------------------------------------------------
REM  Autodetect: Check if a CD-ROM or an Audio-CD is inserted
REM --------------------------------------------------------------------

:AutoDetect
 %LCD% /U /Adr0 /F Detect.lcd > NUL
 CDROM DETECT
 IF ErrorLevel 100 GOTO MODE
 IF ErrorLevel 3 GOTO CDROM
 IF ErrorLevel 2 GOTO AudioCD

 DELAY 2
 CDROM DETECT
 IF ErrorLevel 100 GOTO MODE
 IF ErrorLevel 3 GOTO CDROM
 IF ErrorLevel 2 GOTO AudioCD

 DELAY 4
 CDROM DETECT
 IF ErrorLevel 100 GOTO MODE
 IF ErrorLevel 3 GOTO CDROM
 IF ErrorLevel 2 GOTO AudioCD


REM --------------------------------------------------------------------
REM  Main Menu 1
REM --------------------------------------------------------------------

:Mode
 %WorkDrive%
 BEEP 2000 > NUL
 %LCD% /U /Adr0  /F Main1.lcd > NUL
 BEEP 0 > NUL
 GetPort /K /R0-0  > NUL
 GetPort /K /R1-31 > NUL
 IF ErrorLevel 16 GOTO Mode2
 IF ErrorLevel  8 GOTO Open
 IF ErrorLevel  4 GOTO Drive
 IF ErrorLevel  2 GOTO Options
 IF ErrorLevel  1 GOTO Clock
 Goto Error

REM --------------------------------------------------------------------
REM  Main Menu 2
REM --------------------------------------------------------------------

:Mode2
 BEEP 2000 > NUL
 %LCD% /Adr0  /F Main2.lcd > NUL
 BEEP 0 > NUL
 GetPort /K /R0-0  > NUL
 GetPort /K /R1-31 > NUL
 IF ErrorLevel 16 GOTO Mode
 IF ErrorLevel  8 GOTO CTTY
 IF ErrorLevel  4 GOTO Link
 IF ErrorLevel  2 GOTO Calm
 IF ErrorLevel  1 GOTO Boot
 Goto Error


REM --------------------------------------------------------------------
REM  Items of Main Menu 1: OPEN, DRIVE, OPTIONS, CLOCK
REM --------------------------------------------------------------------

:Open
 BEEP 2000 > NUL
 %LCD% /M /Adr0  /F Opening.lcd > NUL
 BEEP 0 > NUL
 CDROM EJECT > NUL
 %LCD% /Adr0  /F Blank.lcd > NUL
 %LCD% /Adr64 /F Close.lcd > NUL
 GetPort /K /R0-0  > NUL
 GetPort /K /R1-31 > NUL
 IF ErrorLevel 16 GOTO Mode
 BEEP 2000 > NUL
 %LCD% /M /Adr0  /F Closing.lcd > NUL
 BEEP 0 > NUL
 CDROM CLOSE
 REM DELAY 1
 GOTO AutoDetect

:Drive
 %WorkDrive%
 copy drive0.lcd drive.lcd
 PrintChr #%Drive%: >> drive.lcd
 BEEP 2000 > NUL
 %LCD% /Adr0  /F Drive.lcd > NUL
 BEEP 0 > NUL
 GetPort /K /R0-0  > NUL
 GetPort /K /R1-31 > NUL
 IF ErrorLevel 16 GOTO Mode
 IF ErrorLevel  8 GOTO AutoDetect
 IF ErrorLevel  4 GOTO DriveMinus
 IF ErrorLevel  2 GOTO DrivePlus
 IF ErrorLevel  1 GOTO SetDrive
 GOTO Error
 :DriveMinus
  REM  *******************************************************************
  REM  Hier mu an 2 Stellen der Bereich der whlbaren Laufwerksbuchstaben
  REM  (ASCII-Codes) angeben werden:   67 68 bedeutet von C bis D
  REM  *******************************************************************
  SetError %Drive%-1 67 68
  call GetError Drive
  GOTO Drive
 :DrivePlus
  SetError %Drive%+1 67 68
  call GetError Drive
  GOTO Drive
 :CDROM
  REM  *******************************************************************
  REM  Wenn der Laufwerksbuchstabe fr CD-ROM nicht R: ist, bitte ndern:
  REM  *******************************************************************
  SET  Drive=82
 :SetDrive
  PrintChr #%Drive%: > ChDrive.bat
  call ChDrive.bat
  CD \
  IF %AUTOFIND%==OFF GOTO NextPrev
  BEEP 2000 > NUL
  %LCD% /M /Adr0 /F %WorkPath%Search.lcd
  BEEP 0 > NUL
  dir *.mp3 /s /b > %WorkPath%DIR.OUT
  %WorkPath%ShufName %WorkPath%DIR.OUT /T1
  IF ErrorLevel 1 GOTO NoMPEG
 :NextPrev
  Next *.MP? > NUL
  Previous *.MP? > %WorkPath%ZEILE.LCD
  GOTO MPEG

:Options
 del %WorkPath%OPTIONS.BAT
 call SetOpt AutoFindMP3s AUTOFIND %AUTOFIND%
 IF ErrorLevel 16 GOTO Mode
 call SetOpt AutoDisk-Off: AUTOOFF  %AUTOOFF%
 IF ErrorLevel 16 GOTO Mode
 call SetOpt ContinousPlay: CONTPLAY %CONTPLAY%
 IF ErrorLevel 16 GOTO Mode
 call SetOpt ShowID3-tag: SHOWTAG  %SHOWTAG%
 IF ErrorLevel 16 GOTO Mode
 call SetOpt Grabscreen: GRABSCR  %GRABSCR%
 IF ErrorLevel 16 GOTO Mode
 call SetOpt ISO9660-Level2: LEVEL2   %LEVEL2%
 IF ErrorLevel 16 GOTO Mode
 BEEP 2000 > NUL
 %LCD% /M /Adr0  /F SaveOpt.lcd > NUL
 BEEP 0 > NUL
 DELAY 1
 COPY %WorkPath%options.bat %BootDrive%\init
 call %WorkPath%options.bat
 GOTO Mode

:Clock
 BEEP 2000 > NUL
 %LCD% /I
 BEEP 0 > NUL
 call scroll + 16
 %LCD% /C
 call scroll - 16
 :Clock2
  %LCD% /C
  GetPort /K > NUL
  If ErrorLevel 1 GOTO Mode
  GOTO Clock2


REM --------------------------------------------------------------------
REM  Items of Main Menu 2: CTTY, LINK, CALM, BOOT
REM --------------------------------------------------------------------

:CTTY
 %LCD% /Adr0  /F Ctty.lcd > NUL
 rem DosIdle -off
 %WorkPath%COMMAND /E:2048 COM1
 rem DosIdle -on
 GOTO Mode

:Link
 REM  Laplink is not part of the software package!
 REM  It should be possible to invoke other file transfer programs
 REM  instead of Laplink.
 BEEP 2000 > NUL
 %LCD% /M /Adr0  /F Link.lcd > NUL
 BEEP 0 > NUL
 KeyTSR /Set2
 rem DosIdle -off
 %bootdrive%\laplink\llxl
 rem DosIdle -on
 KeyTSR /R
 GOTO Mode

:Calm
 DISKOFF PM
 GOTO Mode

:Boot
 BEEP 2000 > NUL
 %LCD% /Adr0  /F Reboot.lcd > NUL
 BEEP 0 > NUL
 Reboot /N


REM --------------------------------------------------------------------
REM  MP3-Directory-Browser
REM --------------------------------------------------------------------

:MPEG
 %LCD% /Adr64 /F %WorkPath%BROWSE.LCD
 SET Key=---
 SET lastKey=---
 GetPort /K /R0-0  > NUL
:MPEG2
:Disp
 %WorkPath%BEEP 2000 > NUL
 %LCD% /M /Adr0 /F %WorkPath%ZEILE.LCD > NUL
 %WorkPath%BEEP 0 > NUL

REM  - - - - - - Poll keypad status: - - - - - - - - - - - - - - - - - -
:KeyLoop
 SET oldKey=%lastKey%
 SET lastKey=%Key%
 %WorkPath%GetPort /K > NUL
 call %WorkPath%GetError Key
 IF %Key%==000 GOTO NoKey
 IF %Key%==%lastKey% GOTO KeyDelay
:DoKey
 %WorkPath%GetPort /K > NUL
 IF ErrorLevel 1 GOTO DoKey2
 GOTO KeyLoop
:DoKey2
 IF %Key%==016 GOTO Mode
 IF %Key%==008 GOTO Shuffle
 IF %Key%==006 GOTO Skip10
 IF %Key%==004 GOTO Previous
 IF %Key%==002 GOTO Next
 IF %Key%==001 GOTO Enter
 GOTO KeyLoop
:KeyDelay
 REM  Key Repeat Rate:
 %WorkPath%Delay 0.05
 IF %Key%==%oldKey% GOTO DoKey
 REM  Delay for Key Repeat:
 %WorkPath%Delay 0.5
 GOTO DoKey
:NoKey
 IF %oldKey%==000 GOTO KeyLoop

REM  - - - - - - Display ID3-tag or long filename: - - - - - - - - - - -
:GetLong
 IF %SHOWTAG%==OFF GOTO NoTag
 COPY %WorkPath%setvar0.bat+%NameFile% %WorkPath%setvar.bat
 call %WorkPath%setvar.bat
 %WorkPath%ShowTag /F:AT %var% > %WorkPath%LONG.LCD
 IF ErrorLevel 100 GOTO NoTag
 IF ErrorLevel 1 GOTO DispLong
:NoTag
 IF %LEVEL2%==OFF GOTO KeyLoop
 REM  If no MP3-tag is found, try to determine long
 REM  ISO-9660-Level2-filename:
 COPY %WorkPath%setvar0.bat %WorkPath%setvar.bat
 %WorkPath%Combine %PathFile% %NameFile% >> %WorkPath%setvar.bat
 call %WorkPath%setvar.bat
 %WorkPath%CDROM L %var% > %WorkPath%LONG.LCD
 IF ErrorLevel 100 GOTO KeyLoop
 IF ErrorLevel 13  GOTO DispLong
 GOTO KeyLoop
:DispLong
 %LCD% /M /S %WorkPath%LONG.LCD
 GOTO KeyLoop

REM  - - - - - - PLAY-button has been pressed: - - - - - - - - - - - - -
REM  - - - - - - Prepare commandline for decoder (PLAY.BAT): - - - - - -
   :Enter
    BEEP 2000 > NUL
    %LCD% /M /Adr0 /F %WorkPath%ZEILE.LCD > NUL
    IF %GRABSCR%==ON GOTO WithOutput
    copy %WorkPath%PLAY0.BAT %WorkPath%PLAY.BAT
    GOTO Enter2
   :WithOutput
    copy %WorkPath%PLAY1.BAT %WorkPath%PLAY.BAT
   :Enter2
    BEEP 0 > NUL
    Enter >> %WorkPath%PLAY.BAT
    IF ErrorLevel 1 GOTO SubDir

REM  - - - - - - Call MP3-decoder: - - - - - - - - - - - - - - - - - - -
    %LCD% /Adr64 /F %WorkPath%PLAY.LCD > NUL
    IF %GRABSCR%==OFF GOTO Enter3
     %LCD% /T %WorkPath%SCRIPT.LCD
     cls
   :Enter3
     KeyTSR /Q
     REM  Fr DAMP obige Zeile durch folgende ersetzen:
     REM  KeyTSR /Set3 /Q
     call %WorkPath%PLAY.BAT
     GetPort /K /R0-31 > NUL
     call GetError ExitStatus
     KeyTSR /R /Q
     IF %GRABSCR%==OFF GOTO Enter4
     %LCD% /R
    :Enter4
    %WorkPath%SetError %ExitStatus%
    IF ErrorLevel 16 GOTO Mode
    IF ErrorLevel  1 GOTO NextPrev
    REM Titel wurde bis zum Ende gespielt, weil beim Beenden des Dekoders
    REM keine Taste gedrckt war. Jetzt ggf. nchsten Titel starten
    IF %CONTPLAY%==OFF GOTO MPEG
    IF %SHUFFLE%==ON GOTO Shuffle2
    Next *.MP? > %WorkPath%ZEILE.LCD
    IF ErrorLevel 3 GOTO MPEG
    %LCD% /Adr0 /F %WorkPath%ZEILE.LCD > NUL
    GOTO Enter

REM  - - - - - - Other functions of Browser-menu:  - - - - - - - - - - -
    ::           "SHUF"   "<<"   ">>"

    REM  Goto next file in directory:
   :Next
    Next *.MP? > %WorkPath%ZEILE.LCD
    SET SHUFFLE=OFF
    GOTO MPEG2

    REM  Goto previous file in directory:
   :Previous
    Previous *.MP? > %WorkPath%ZEILE.LCD
    SET SHUFFLE=OFF
    GOTO MPEG2

   :Skip10
    Next *.MP? 10 > %WorkPath%ZEILE.LCD
    SET SHUFFLE=OFF
    GOTO MPEG2

   :Shuffle
    IF %SHUFFLE%==ON GOTO ShufOn
    BEEP 1000 > NUL
    %LCD% /M /Adr0 /F %WorkPath%Shuffle1.lcd > NUL
    BEEP 0 > NUL
    SET SHUFFLE=ON
    Delay 0.2
    dir *.mp3 /s /b > %WorkPath%DIR.OUT
   :Shuffle2
    ShufName %WorkPath%DIR.OUT
    IF ErrorLevel 1 GOTO NoMPEG
    Previous *.MP? > %WorkPath%ZEILE.LCD
    Next *.MP? > %WorkPath%ZEILE.LCD
    %LCD% /Adr0 /F %WorkPath%ZEILE.LCD > NUL
    GOTO Enter
   :ShufOn
    BEEP 1000 > NUL
    %LCD% /M /Adr0 /F %WorkPath%Shuffle2.lcd > NUL
    BEEP 0 > NUL
    Delay 0.5
    GOTO Shuffle2

   :SubDir
    Next *.MP? > %WorkPath%ZEILE.LCD
    GOTO MPEG


REM --------------------------------------------------------------------
REM  Audio-CD Playback: See AUDIOCD.BAT
REM --------------------------------------------------------------------

:AudioCD
 call AudioCD.BAT
 GOTO Mode


REM --------------------------------------------------------------------
REM  Misc functions
REM --------------------------------------------------------------------

:NoMPEG
 %LCD% /Adr0  /F %WorkPath%NoFiles.lcd > NUL
 BEEP 1000 > NUL
 Delay 0.1
 BEEP 500 > NUL
 Delay 0.1
 BEEP 0 > NUL
 Delay 2
 GOTO Drive

:Error
 BEEP 4000 > NUL
 %LCD% /Adr0  /M Error in Master Control Program!
 %LCD% /Adr64 /M Hold down any key to continue...
 BEEP 0 > NUL
 cd %WorkPath%
 call Scroll - 16
 BEEP 1000 > NUL
 ECHO Error in MCP.BAT!
 BEEP 0 > NUL
 call Scroll + 16
 GetPort /K > NUL
 If ErrorLevel 1 GOTO AutoDetect
 GOTO Error
:End
