; **********************************************************************
; ************* COMBINE liest 2 Dateien ein und gibt ihren Inhalt     **
; ************* in einer einzigen Zeile aus.                          **
; ************* (C) 1999-06-10 by Klaus Peichl                        **
; *************                   Dornbergstr. 10                     **
; *************                   91058 Erlangen-Tennenlohe           **
; *************                   (pei@freenet.de)                    **
; **********************************************************************

		.Model tiny
		.Code
		Org 100h

; ----------------------------------------------------------------------
  INT21         MACRO
		LOCAL Ok
; ----------------------------------------------------------------------
		int 21h
		jnc Ok
		mov dx,Offset FileErrStr
		mov ah,9
		int 21h
		mov ErrorLevel,100
                jmp Ende
	    ok: ENDM


; **********************************************************************
; ************* Hauptprogramm                                         **
; **********************************************************************

Start:          cmp sp,Offset Stapelend
                ja  StapelOk
                mov dx,Offset NoMemStr
                mov ah,9
                int 21h
                jmp Ende

StapelOk:       push ds
		pop es
		cld

; ************* Kommandozeile parsen: **********************************

		mov si,80h
                lodsb
                cmp al,3
                ja ParamsPresent
                mov dx,Offset SyntaxStr
                mov ah,9
                int 21h
                mov ErrorLevel,101
                jmp Ende

ParamsPresent:  call ReadFile
                call PrintLine
                inc ErrorLevel
                mov dx,Offset BackslashStr
                mov ah,9
                int 21h
                call ReadFile
                call PrintLine

Ende:           mov al,Errorlevel
		mov ah,4ch
		int 21h


; ------------------------------------------------------------------------
  PrintLine:
; ------------------------------------------------------------------------
                push si

                mov dx,Offset Puffer
                mov si,dx
                cld

ScanEnd:        lodsb
                cmp al,':'
                jne n_DriveLetter
                mov dx,si
 n_DriveLetter: cmp al,13
                ja ScanEnd
                dec si
                mov Byte Ptr [si],'$'   ; Endmarkierung des Strings setzen
                mov ax,si
                sub ax,dx
                add ErrorLevel,al   ; Breite aufsummieren

                mov ah,9
                int 21h
                pop si
                ret


; ------------------------------------------------------------------------
  ReadFile:
; ------------------------------------------------------------------------
; Liest die als Parameter angegebene Datei in den Pufferspeicher
; (max. 2000 Zeichen)
; Eingabe:        si = Index in Kommandozeile ab dem nach dem Dateinamen
;                      gesucht wird
; Rckgabe:       si = Index in Kommandozeile hinter dem Dateinamen

ScanNameBegin:  lodsb
		cmp al,' '
		je ScanNameBegin
                mov dx,si               ; Anfangspos. Dateiname
                dec dx

ScanNameEnd:    lodsb
		cmp al,' '
		ja ScanNameEnd

		dec si
		mov Byte Ptr [si],0     ; Dateiname-Endmarkierung setzen
                inc si

		mov ax,3D00h            ; Open File (read)
		INT21

OpenOk:         mov bx,ax               ; bx := Handle
		mov cx,2000
		mov dx,Offset Puffer
		mov ax,3F00h            ; Daten einlesen
		INT21

		mov di,ax               ; Anzahl gelesener Bytes
                mov [Puffer+di],0       ; String-Endmarkierung setzen

		mov ax,3E00h            ; Datei schlieen
		INT21

                ret



; ************************************************************************
; ************* Konstanten und Variablen                                **
; ************************************************************************

SyntaxStr       DB 'COMBINE  (c) 1999-06-10 by Klaus Peichl',10,10,13
                DB 'This tool reads path and filename from two files and prints',10,13
                DB 'all on one single line. ',10,10,13
		DB 'Syntax:       COMBINE <File1> <File2>',10,13
                DB 'Return value: 0=all ok, 100=file error, 101=syntax error,',10,13
                DB '              else=width of output',10,13,'$'
NoMemStr        DB '?OUT OF MEMORY  ERROR',10,13,'$'
FileErrStr      DB 'COMBINE Fatal: File I/O Error!'
CR              DB 10,13,'$'
BackslashStr    DB '\$'
ErrorLevel      DB 0
Puffer          DB 2002 Dup (?)
Stapel          DB 500 Dup (?)
StapelEnd       DB ?
		END Start
