Program Enter;
uses Dos;

{ Hilfsprogramm zum MPEG-CD-Player.
  1. Wechselt in das Verzeichnis, das in <PathFile> steht
  2. Falls <NameFile> einen MPEG-Titel angibt, wird ein Batchprogramm
     zum Abspielen generiert.
     Ansonsten wird der Inhalt von <NameFile> als Unterverzeichnis
     interpretiert und dorthin gewechselt.

  (C) 15.05.1998 by Klaus Peichl, stl. Ringstr. 7, 85113 Bhmfeld
                    E-mail: kspeichl@cip.e-technik.uni-erlangen.de
  Rechner:  IBM-kompatibler PC
  Compiler: Borland Turbo-Pascal 6.0                               }

Var f                     : text;
    Pfad, Datei, Zeile, s : String;
    DirInfo, diVor        : SearchRec;
    Nummer                : Integer;
    KB                    : Word;


Function DispZeile(DirInfo:SearchRec):String;
Var NumStr, s : String;
Begin
  s:=DirInfo.Name;
  If DirInfo.Attr=Directory
    then s:='   '+s+'           '
    else begin
      If Nummer< 100
        then begin Str(Nummer:2, NumStr); NumStr:=NumStr+' '; end
        else Str(Nummer:3, NumStr);
      s:=Copy(s,1,Pos('.MP',s)-1);
      s:=Copy(s+'        ',1,8);
      While length(s)<9 do s:=s+' ';
      s:=NumStr+s;
      Str(DirInfo.Size div 1024:4, NumStr );
      s:=s+NumStr;
    end;
  DispZeile:=Copy(s,1,16);
end;


Function GetLine(EnvVar:string):string;
{ ffnet die Datei, deren Name mit der als Argument bergebenen
  Umgebungsvariablen festgelegt ist und liefert die erste Zeile
  als String zurck }

Var s:string;
Begin
  s:=GetEnv(EnvVar);
  if s='' then begin
    writeln('Environment variable ',EnvVar,' must be set!');
    Halt(100);
  end else begin
    Assign(f,s);
    {$I-} Reset(f); {$I+}
    If IOResult<>0 then begin
      writeln('File "',s,'" not found!');
      Halt(101);
    end;
    Readln(f,s);
    Close(f);
    GetLine:=s;
  end;
end;


Function LastPart(Pfad:String):String;
Var l,i:Integer;
Begin
  l:=length(Pfad);
  (* Den hinteren Backslash entfernen: *)
  If l>1 then If Pfad[l]='\' then Pfad:=Copy(Pfad,1,l-1);

  i:=l;
  Repeat
    dec(i);
  until (i<=0) or (Pfad[i]='\');
  If i>0 then LastPart:=Copy(Pfad,i+1,l-i)
         else LastPart:='---';
end;


Begin
  Pfad :=GetLine('PATHFILE');
  Datei:=GetLine('NAMEFILE');

  {$I-} chdir(Pfad); {$I+}
  If IOResult<>0 then begin
    Writeln('ENTER.EXE - Invalid Path: '+Pfad);
    Halt(103);
  end;

  Writeln(Datei);

  {$I-} chdir(Datei); {$I+}
  If IOResult=0 then begin
    { Datei bezeichnet ein Directory }

    (* Wenn im Verzeichnisbaum eine Ebene zurck gegangen wird, soll
       man sich im Directory-Browser an der aktuellen Stelle
       wiederfinden:                                           *)
    If Datei='..' then Datei:=LastPart(Pfad);

    Assign(f,GetEnv('NAMEFILE'));
    Rewrite(f);
    Writeln(f,Datei);
    Close(f);

    GetDir(0,Pfad);
    Assign(f,GetEnv('PATHFILE'));
    Rewrite(f);
    Writeln(f,Pfad);
    Close(f);
    Halt(1);
  end else begin
    { Datei bezeichnet eine Sounddatei }
    Halt(0);
  end;
end.