; KEYPANEL
; Gertetreiber fr Tastenpanel am Parallelport
; (C) 01.05.1998 by Klaus Peichl, stliche Ringstr. 7, 85113 Bhmfeld
;
; Assemblierung mit Borland-Turbo-Assembler:
; TASM ...
; TLINK ...
; EXE2BIN ...
;
; Infos ber Gertetreiber z.B. in DOS EXTRA 8/89
;
; Druckerport:
; Statusleitungen: Bit 7 (128) ist invertiert (/Busy)
; Steuerleitungen: Bits 0,1,3 sind invertiert, Bit 2 (4) normal.


            .MODEL tiny
            .Code
            ORG 0


; ---------------------------------------------------------------------
;  Device-Header:
; ---------------------------------------------------------------------
            DD 0FFFFFFFFh               ; Zeiger auf nchsten Treiber
            DW 1110000000010000b        ; Attribute
            DW Offset StratRoutine
            DW Offset IntRoutine
            DB 'KEYPAD  '


; ---------------------------------------------------------------------
;  unverschlsselt bentigte Daten
; ---------------------------------------------------------------------

Sprungtabelle:
            DW Offset Init              ; Kommando 0
            DW Offset Dummy             ;          1
            DW Offset Dummy             ;          2
            DW Offset IoctlRead         ;          3
            DW Offset Read              ;          4
            DW Offset NonDesRead        ;          5
            DW Offset InputStatus       ;          6
            DW Offset FlushInBuffer     ;          7
            DW Offset Dummy             ;          8
            DW Offset Dummy             ;          9
            DW Offset Dummy             ;         10
            DW Offset Dummy             ;         11
            DW Offset IoctlWrite        ;         12

; ---------------------------------------------------------------------
;  Strategie-Routine:
; ---------------------------------------------------------------------

StratRoutine:
            mov cs:word ptr DosZeiger, bx   ; Zeiger auf Request Header
            mov cs:word ptr DosZeiger+2,es  ;  zwischenspeichern
            retf


; ---------------------------------------------------------------------
;  Interrupt-Routine des Treibers:
; ---------------------------------------------------------------------

IntRoutine: mov CS:[StackPtr],sp
            mov CS:[StackSeg],ss
            mov CS:[CodeSegment],cs
            cli
            mov ss,CS:[CodeSegment]
            mov sp,Offset StackEnde
            sti
            push ax
            push bx
            push cx
            push dx
            push si
            push di
            push bp
            push ds
            push es
            pushf

            push cs
            pop  ds                     ; ds:=cs

            les di,[DosZeiger]          ; ES:DI = request header
            mov bl,es:[di+2]
            xor bh,bh                   ; BX = Kommandocode

            cmp bl,12                   ; zulssiges Kommando?
            jbe Cmd_ok
            mov ax,3                    ; unknown Command
            jmp SetStatus

; Beim Aufruf des durch bx gewhlten Unterprogramms gelten folgende
; Registerinhalte:
;  ds=cs=Daten- und Codesegment
;  es=Segment der Dosparameter
; Dabei mu ds erhalten bleiben
Cmd_ok:     shl bx,1
            push es
            call word ptr [Sprungtabelle+bx]
            pop es

SetStatus:  or ax,0100h                 ; Done_flag setzen
            les di,[DosZeiger]
            mov es:[di+3],ax            ; Status zurckliefern

            popf
            pop es
            pop ds
            pop bp
            pop di
            pop si
            pop dx
            pop cx
            pop bx
            pop ax
            cli
            mov sp,CS:[StackPtr]
            mov ss,CS:[StackSeg]
            sti
            retf

; ---------------------------------------------------------------------
;  Funktion 0 (Init): Meldung, Parameterauswertung
; ---------------------------------------------------------------------

Init:       mov dx,Offset Meldung
            mov ah,9
            int 21h

            call ParameterAuswertung
            call SetPort
            xor ax,ax
            ret


; ---------------------------------------------------------------------
;  weitere Funktionen der Interrupt-Routine:
; ---------------------------------------------------------------------


; bergebene Informationen:
; 0 Kennung 'KP'
; 2 Partition
; 3 Wartezeit
; -
IoctlRead:  push ds
            mov bx,Word Ptr es:[di+14]  ; bergabepuffer Offset
            mov ax,bx
            mov ax,Word Ptr es:[di+16]  ; bergabepuffer Segment
            mov ds,ax
            mov [bx],'KP'
            ;            mov al,CS:PartNr
            mov [bx+2],al
            ; mov ax,CS:WarteZeit
            mov [bx+3],ax
            pop ds
            ret


Read:       mov si,SequenzPtr
            or  si,si
            jnz DoSequenz
            call InPort                 
            cmp  al,Status
            jne Wechsel2
            jmp Read                    ; wartet ewig auf Taste!
  Wechsel2: mov Status,al
 
            mov ah,0
            int 1Ah                     ; Timer lesen
            mov bx,TimerHigh
            mov ax,TimerLow
            mov TimerHigh,cx
            mov TimerLow,dx
            sub dx,ax                   ; dx = Low-Differenz
            sbb cx,bx                   ; cx = High-Differenz
            jnz sehr_lang
            cmp dx,1                    ; 2/18 Sekunden
            ja lang
            jmp Read                    ; Zeit war zu Kurz => Prellkontakt
  lang:
  sehr_lang:
            mov al,Status
            cmp al,0                    ; nur losgelassen?
            jz  Read

            cmp al,64
            jne n_Taste1
            mov bx,Offset Sequenz1
            jmp Taste_ein
 n_Taste1:  cmp al,128
            jne n_Taste2
            mov bx,Offset Sequenz2
            jmp Taste_ein
 n_Taste2:  cmp al,32
            jne n_Taste3
            mov bx,Offset Sequenz3
            jmp Taste_ein
 n_Taste3:  cmp al,16
            jne n_Taste4
            mov bx,Offset Sequenz4
            jmp Taste_ein
 n_Taste4:  cmp al,8
            jne n_Taste5
            mov bx,Offset Sequenz5
            jmp Taste_ein
 n_Taste5:  xor bx,bx
 Taste_ein: mov SequenzPtr,bx
            jmp Read                    ; neue Sequenz gleich anfangen

 DoSequenz: mov bx,1                    ; 1 Zeichen gelesen
            cld
            lodsb
            mov SequenzPtr,si
            les di,es:[di+14]           ; di = Offset des Puffers
            stosb
            lodsb
            cmp al,255                  ; Sequenzende?
            jne ReadEnd
            mov SequenzPtr,0
 ReadEnd:
            les di,[DosZeiger]          ; ES:DI = request header
            mov ES:[DI+18],bx           ; Anzahl gelesener Zeichen
            xor ax,ax
            ret


NonDesRead: ;call InputStatus
            mov si,SequenzPtr
            or  si,si
            jnz DoSequenz2
            mov al,' '
            ;call InputStatus
            ;jmp Read
            xor bx,bx                   ; 0 Zeichen gelesen
            jmp ReadEnd2
 DoSequenz2: mov bx,1                    ; 1 Zeichen gelesen
            cld
            lodsb
            les di,es:[di+14]           ; di = Offset des Puffers
            stosb
 ReadEnd2:  les di,[DosZeiger]          ; ES:DI = request header
            mov ES:[DI+18],bx
            xor ax,ax
            ret


; Rckgabe: ax=0200h (Busy), falls keine Daten parat sind
;           ax=0000h       , falls Sequenz luft oder Taste gedrckt
InputStatus: cmp SequenzPtr,0
             jnz DatenDa

            call Inport
            cmp al,Status
            jne Wechsel
  NoKey:    mov ax,0200h                ; Busy-Flag setzen: keine Daten
            jmp InStatEnd

 Wechsel:   cmp al,0                    ; Taste nur losgelassen?
            je NoKey

  DatenDa:  xor ax,ax                   ; Busy-Flag lschen
  InStatEnd: ret



; Liest die Statusleitungen
; verndert keine Register
; Ergebnis in al
InPort:
            push dx
            mov dx,DatenPort
            mov al,80h
            out dx,al                  ; Bit 7 = 5V (fuer Joystickadapter)
            mov dx,SteuerPort
            mov al,0h                  ; Bit 1 mu 0 sein, damit Pin14=5V
            out dx,al
            mov dx,StatusPort
            in  al,dx
            and al,11111000b            ; Statusleitungen extrahieren
            xor al,10000000b            ; Busy-Pegel invertieren
            xor al,11111000b
            pop dx
            ret


FlushInBuffer: mov SequenzPtr,0
               ret

IoctlWrite:
; Hier knnen folgende Steuerungen vorgenommen werden:
; - Umschalten der aktuellen Sequenz auf SequenzUser
; Die Funktion wird durch einen Code anstelle der Sektoranzahl gewhlt
            ;mov ax, Word Ptr es:[di+18] ; Funktionscode statt Sector-Count
            ;mov bx, Word Ptr es:[di+14] ; Parameter statt Puffer-Offset
            ;cmp ax,'/P'
            mov SequenzPtr,Offset SequenzUser
Dummy:      ret


; ---------------------------------------------------------------------
;  Unterprogramme:
; ---------------------------------------------------------------------


Newline:    push ax
            push dx
            push cs
            pop ds
            mov ah,9
            mov dx,Offset CR
            int 21h
            pop dx
            pop ax
            ret


; *************************************************
; *  Hex-Zahlausgabe                              *
; *  Eingabe:         ax = Zahl bei PrintHexWord  *
; *             bzw.  al = Zahl bei PrintHexByte  *
; *************************************************
PrintHexWord:   xchg al,ah
                call PrintHexByte
                xchg al,ah
                call PrintHexByte
                ret

PrintHexByte:   push dx
                mov dl,al
                shr dl,1
                shr dl,1
                shr dl,1
                shr dl,1
		call Ziffer
		mov dl,al
		call Ziffer
		pop dx
		ret

  Ziffer:       and dl,0Fh
                add dl,'0'
		cmp dl,'9'
		jbe Schreibe_Ziffer
                add dl,7
  Schreibe_Ziffer: push ax
		mov ah,2
		int 21h
		pop ax
		ret


;----------------------------------------------------------------------
 Parameterauswertung:
;----------------------------------------------------------------------
            push ds
            mov si,Word Ptr es:[di+18]  ; Offset der Kommandozeile
            mov ax,Word Ptr es:[di+20]  ; Segment der Kommandozeile
            mov ds,ax
            cld
  Parameter: lodsb
            cmp al,13                   ; End of Line?
            ja  Param
            jmp ParamEnd
    Param:  cmp al,'/'
            jnz Parameter
            lodsb
            and al,0DFh                 ; Klein->Grobuchstabe

            cmp al,'D'                  ; D?
            jne kein_D
            inc CS:[Debug]
            jmp Parameter

    kein_D: cmp al,'L'                  ; Parameter /LPTx
            jne kein_L
            lodsw                       ; 'PT' berlesen
            lodsb
            sub al,'1'
            cmp al,3
            ja Paramfalsch
            mov CS:[LPT],al
            jmp Parameter
    kein_L:
Paramfalsch:
  ParamEnd: pop ds                      ; DS wiederherstellen
            ret



;----------------------------------------------------------------------
 SetPort:
;----------------------------------------------------------------------
            mov bl,[LPT]
            shl bl,1
            mov bh,0
            push es
            mov ax,0040h                ; Adresse der par. Schnittstelle
            mov es,ax                   ; ermitteln
            mov ax,ES:[8+bx]
            pop es
            mov DatenPort,ax
            inc ax
            mov StatusPort,ax
            inc ax
            mov SteuerPort,ax

            mov Word Ptr es:[di+14],Offset Ende  ; Zeiger auf Treiberende
            mov Word Ptr es:[di+16],cs
            ret


; ---------------------------------------------------------------------
;  Konstanten und initialisierte Daten:
; ---------------------------------------------------------------------

Status      DB 0
Debug       DB 0
LPT         DB 0                        ; 0=LPT1, 1=LPT2, 2=LPT3, 3=LPT4
DatenPort   DW 0378h
StatusPort  DW 0379h
SteuerPort  DW 037Ah

            DB '۲ Klaus Peichl (email: peichl@usa.net) '

Sequenz1    DB 4,255                     ; emuliert Ctrl D
Sequenz2    DB 3,255                     ; emuliert Ctrl C
Sequenz3    DB 2,255                     ; emuliert Ctrl B
Sequenz4    DB 1,255                     ; emuliert Ctrl A
Sequenz5    DB 32,255                    ; emuliert Space
;Sequenz1    DB 27,255                   ; emuliert Escape-Taste
;Sequenz2    DB 0,75,255                 ; emuliert Cursor-Links
;Sequenz3    DB 0,77,255                 ; emuliert Cursor-Rechts
;Sequenz4    DB 13,255                   ; emuliert Enter
;Sequenz5    DB 32,255                   ; emuliert Space
SequenzUser DB 255
SequenzPtr  DW 0

Meldung     DB 'KeyPanel 0.9, (c) 1998 Klaus Peichl'
            DB 10,13,'Device name: KEYPAD'
CR          DB 10,13,'$'
NoInstStr   DB 10,13,'KeyPanel not installed!',10,13,'$'

; ---------------------------------------------------------------------
;  nicht initialisierte Daten:
; ---------------------------------------------------------------------

TimerHigh   DW ?
TimerLow    DW ?
Fehler      DB ?
DosZeiger   DD ?
StackAnfang DW 100 Dup (?)
StackEnde   DW ?
StackPtr    DW ?                        ; alter Inhalt von SP
StackSeg    DW ?                        ; alter Inhalt von SS
CodeSegment DW ?
Ende        DB ?

            END