Program Next;
uses Dos;

{ Sucht den nchsten MPEG-Titel
  (C) 31.05.1998 by Klaus Peichl, stl. Ringstr. 7, 85113 Bhmfeld
                    E-mail: pei@freenet.de
  Rechner:  IBM-kompatibler PC
  Compiler: Borland Turbo-Pascal 6.0                               }

Var f                                        : text;
    Pfad, Datei, Zeile, s, Maske, MaskenKern : String;
    PfadFile, DateiFile, DispFile            : String;
    DirInfo                                  : SearchRec;
    Nummer, Step, x, return                  : Integer;
    KB                                       : Word;
    lastOk                                   : Boolean;

Function DispZeile(DirInfo:SearchRec):String;
Var NumStr, s : String;
    i         : Integer;
Begin
  s:=DirInfo.Name;
  { Das Directory-Attribut ist manchmal beim SHSUCDX-Treiber nicht gesetzt,
    dafr aber das VolumeID-Attribut }
  If (DirInfo.Attr and (Directory+VolumeID))>0
    then begin
      i:=Pos('.',s);
      If (i>1) and (i<length(s)) then Delete(s,i,1);
      s:='   '+s+'            ';
      s:=Copy(s,1,16)+'DIR.';
    end else begin
      If Nummer< 100
        then begin Str(Nummer:2, NumStr); NumStr:=NumStr+' '; end
        else Str(Nummer:3, NumStr);
      s:=Copy(s,1,Pos(MaskenKern,s)-1);
      s:=Copy(s+'        ',1,8);
      While length(s)<9 do s:=s+' ';
      s:=NumStr+s;
      Str(DirInfo.Size div 1024:4, NumStr );
      s:=s+NumStr+' KB ';
    end;
  DispZeile:=s;
end;


Function GetLine(EnvVar:string):string;
{ ffnet die Datei, deren Name mit der als Argument bergebenen
  Umgebungsvariablen festgelegt ist und liefert die erste Zeile
  als String zurck }

Var s:string;
Begin
  s:=GetEnv(EnvVar);
  if s='' then begin
    writeln('Environment variable ',EnvVar,' must be set!');
    Halt(100);
  end else begin
    Assign(f,s);
    {$I-} Reset(f); {$I+}
    If IOResult<>0 then begin
      writeln('File "',s,'" not found!');
      Halt(101);
    end;
    Readln(f,s);
    Close(f);
    GetLine:=s;
  end;
end;


Procedure GetMaske;
Var i1,i2,l:Integer;
Begin
  Maske:=ParamStr(1);

  { In Grobuchstaben umwandeln }
  For l:=1 to length(Maske) do Maske[l]:=Upcase(Maske[l]);

  { Im Maskenkern wird der Teil von Maske gespeichert, der vorn und
    hinten keine Jokerzeichen hat (und auch in der Mitte keine haben
    sollte) }
  i1:=1; i2:=l;
  While (Maske[i1] in ['?','*']) and (i1<l) do inc(i1);
  While (Maske[i2] in ['?','*']) and (i2>1) do dec(i2);
  MaskenKern:=Copy(Maske,i1,i2-i1+1);
end;


Begin
  If ParamCount=0 then begin
    writeln('NEXT  (C) 1998-2002 by Klaus Peichl');
    writeln;
    writeln('Syntax:   NEXT <Mask> [step]');
    writeln('example:  NEXT *.MP? 10');
    writeln;
    writeln('This tool expects two files which names are given by the environment');
    writeln('variables PATHFILE and NAMEFILE. The corresponding files must contain');
    writeln('one line each:  <PathFile>: Current path (for example "R:\MP3")');
    writeln('                <NameFile>: Current file name (for example "SONG.MP3")');
    writeln;
    writeln('NEXT changes to the directory given in <PathFile> and searches for the');
    writeln('filename given in <NameFile>. Then, the next filename matching <Mask>');
    writeln('in this directory is determined and <NameFile> is changed accordingly.');
    writeln('Additionally, the new filename, size and number in the directory are');
    writeln('printed and can be rerouted to a file in order to be displayed on the');
    writeln('LCD later.');
    writeln('Optionally, files may be skipped by supplying the step parameter');
    writeln('(Default: step=1).');
    writeln;
    writeln('Errorlevels:  1 found next file                    100 Missing Env-var.');
    writeln('              2 found next directory               101 Wrong Env-var.');
    writeln('              3 wrap-around to first directory     102 File not found');
    writeln('              4 wrap-around to first file          103 Dir not found');
    Halt(0);
  end;

  If ParamCount=2 then begin
    Val(ParamStr(2),Step,Nummer);
    If Nummer<>0 then Step:=1;
  end
  else Step:=1;

  Pfad :=GetLine('PATHFILE');
  Datei:=GetLine('NAMEFILE');

  GetMaske;

  {$I-} chdir(Pfad); {$I+}
  If IOResult<>0 then GetDir(0,Pfad);

  Nummer:=1;


  (*****   Bis zum alten Dateinamen vorrcken   *****)

  FindFirst(Maske, 0, DirInfo);

  If (Datei<>DirInfo.Name) then
  Repeat
    FindNext(DirInfo);
    inc(Nummer);
  until (DirInfo.Name=Datei) or (DosError<>0);
  lastOk:=(DosError=0);

  (* Aktuelle Datei gefunden, jetzt um die gewnschte Zahl weiter
     springen oder so lange, bis ein wirklich anderer Dateiname
     auftaucht. *)
  x:=0;
  While (DosError=0) and ( (x<Step) or (DirInfo.Name=Datei) ) do begin
    FindNext(DirInfo);
    inc(Nummer);
    inc(x);
  end;

  If DosError=0 then return:=1

  else begin
    Nummer:=1;

    If (lastOk) then begin
      (* Die alte Datei war die letzte im Directory
         Wrap-around und zeige erstes Subdir *)

      return:=3;
      FindFirst('*.*', Directory, DirInfo);
      While ( ((DirInfo.Attr and Directory)=0) or (DirInfo.Name='.')) and (DosError=0) do
        FindNext(DirInfo);

      { Falls kein Directory vorhanden, ersten Titel nehmen }
      If DosError<>0 then begin
        return:=4;
        FindFirst(Maske, 0, DirInfo);
      end;

      If DosError<>0 then begin
        Halt(102);
      end;

    end else begin

      { Nchstes DIRECTORY suchen: }

      FindFirst('*.*', Directory, DirInfo);
      While (DirInfo.Name<>Datei) and (DosError=0) do begin
        FindNext(DirInfo);
      end;

      { Auch normale Dateien werden gefunden! }
      Repeat
        FindNext(DirInfo);
        inc(x);
      Until ( (x>=Step) and ((DirInfo.Attr and Directory)=Directory)) or (DosError<>0);

      If DosError=0 then begin
        { nchstes Directory gefunden }
        Zeile:=DispZeile(DirInfo);
        return:=2;
      end else begin
        (* Es kommt kein Verzeichnis mehr
           => ersten Titel nehmen *)

        FindFirst(Maske, 0, DirInfo);

        If DosError<>0 then begin
          { Es gibt keinen Titel hier, erstes Directory nehmen }
          return:=3;
          FindFirst('*.*', Directory, DirInfo);
          While ( ((DirInfo.Attr and Directory)=0) or (DirInfo.Name='.')) and (DosError=0) do
          FindNext(DirInfo);
          If DosError<>0 then begin
            Halt(103);
          end;
        end;
      end;

    end;
  end;

  { Zeile mit nchster Datei zusammenstellen: }
  Zeile:=DispZeile(DirInfo);
  Writeln(Zeile);

  { Neuen Dateinamen in File schreiben }
  Datei:=DirInfo.Name;

  Assign(f,GetEnv('NAMEFILE'));
  Rewrite(f);
    Writeln(f,Datei);
  Close(f);

  Halt(return);
end.
