Program Previous;
uses Dos;

{ Sucht den MPEG-Titel vor der aktuellen Datei
  (C) 15.05.1998 by Klaus Peichl, stl. Ringstr. 7, 85113 Bhmfeld
                    E-mail: pei@freenet.de
  Rechner:  IBM-kompatibler PC
  Compiler: Borland Turbo-Pascal 6.0                               }

Var f                                        : text;
    Pfad, Datei, Zeile, s, Maske, MaskenKern : String;
    PfadFile, DateiFile, DispFile            : String;
    DirInfo, diVor, diLast                   : SearchRec;
    Nummer, return                           : Integer;
    KB                                       : Word;


Function DispZeile(DirInfo:SearchRec):String;
Var NumStr, s : String;
    i         : Integer;
Begin
  s:=DirInfo.Name;
  { Das Directory-Attribut ist manchmal beim SHSHCDX-Treiber nicht gesetzt,
    dafr aber das VolumeID-Attribut }
  If (DirInfo.Attr and (Directory+VolumeID))>0
    then begin
      i:=Pos('.',s);
      If (i>1) and (i<length(s)) then Delete(s,i,1);
      s:='   '+s+'            ';
      s:=Copy(s,1,16)+'DIR.';
    end else begin
      If Nummer< 100
        then begin Str(Nummer:2, NumStr); NumStr:=NumStr+' '; end
        else Str(Nummer:3, NumStr);
      s:=Copy(s,1,Pos(MaskenKern,s)-1);
      s:=Copy(s+'        ',1,8);
      While length(s)<9 do s:=s+' ';
      s:=NumStr+s;
      Str(DirInfo.Size div 1024:4, NumStr );
      s:=s+NumStr+' KB ';
    end;
  DispZeile:=s;
end;


Function GetLine(EnvVar:string):string;
{ ffnet die Datei, deren Name mit der als Argument bergebenen
  Umgebungsvariablen festgelegt ist und liefert die erste Zeile
  als String zurck }

Var s:string;
Begin
  s:=GetEnv(EnvVar);
  if s='' then begin
    writeln('Environment variable ',EnvVar,' must be set!');
    Halt(100);
  end else begin
    Assign(f,s);
    {$I-} Reset(f); {$I+}
    If IOResult<>0 then begin
      writeln('File "',s,'" not found!');
      Halt(101);
    end;
    Readln(f,s);
    Close(f);
    GetLine:=s;
  end;
end;


Procedure GetMaske;
Var i1,i2,l:Integer;
Begin
  Maske:=ParamStr(1);

  { In Grobuchstaben umwandeln }
  For l:=1 to length(Maske) do Maske[l]:=Upcase(Maske[l]);

  { Im Maskenkern wird der Teil von Maske gespeichert, der vorn und
    hinten keine Jokerzeichen hat (und auch in der Mitte keine haben
    sollte) }
  i1:=1; i2:=l;
  While (Maske[i1] in ['?','*']) and (i1<l) do inc(i1);
  While (Maske[i2] in ['?','*']) and (i2>1) do dec(i2);
  MaskenKern:=Copy(Maske,i1,i2-i1+1);
end;


Begin
  If ParamCount=0 then begin
    writeln('PREVIOUS  (C) 1998-2002 by Klaus Peichl');
    writeln;
    writeln('Syntax:   PREVIOUS <Mask>');
    writeln('example:  PREVIOUS *.MP?');
    writeln;
    writeln('This tool expects two files which names are given by the environment');
    writeln('variables PATHFILE and NAMEFILE. The corresponding files must contain');
    writeln('one line each:');
    writeln('<PathFile>: Current path (for example "R:\MP3")');
    writeln('<NameFile>: Current file name (for example "SONG.MP3")');
    writeln;
    writeln('PREVIOUS changes to the directory given in <PathFile> and searches for the');
    writeln('filename given in <NameFile>. Then, the previous filename matching <Mask>');
    writeln('in this directory is determined and <NameFile> is changed accordingly.');
    writeln('Additionally, the new filename, size and number in the directory are');
    writeln('printed and can be rerouted to a file in order to be displayed on the');
    writeln('LCD later.');
    writeln;
    writeln('Errorlevels:  1 found previous file                100 Missing Env-var.');
    writeln('              2 found next directory               101 Wrong Env-var.');
    writeln('              3 wrap-around to first directory     102 File not found');
    writeln('              4 wrap-around to first file');
    Halt(0);
  end;

  Pfad :=GetLine('PATHFILE');
  Datei:=GetLine('NAMEFILE');

  GetMaske;

  {$I-} chdir(Pfad); {$I+}
  If IOResult<>0 then GetDir(0,Pfad);
  Nummer:=0;


  { Vorgegebene Datei, die davor und die letzte suchen: }

  FindFirst(Maske, 0 , DirInfo);
  If DosError<>0 then diLast.Name:=''
  else begin
    Repeat
      diVor:=DirInfo;
      FindNext(DirInfo);
      inc(Nummer);
    until (DirInfo.Name=Datei) or (DosError<>0);
    diLast:=diVor;
  end;


  If DosError=0 then return:=1
  else begin

    { Voriges DIRECTORY suchen: }

    FindFirst('*.*', Directory, DirInfo);

    diVor:=diLast;
    Repeat
      If ((DirInfo.Attr and Directory)>0) and (DirInfo.Name<>'.') then diVor:=DirInfo;
      FindNext(DirInfo);
    until ((DirInfo.Name=Datei) and (diVor.Name<>'')) or (DosError<>0);

    if DosError=0 then return:=2
    else begin
      { Wrap-around vom ersten Dir zur letzten Datei/Dir: }
      if diLast.Name='' then begin
        return:=3;
      end else begin
        if diVor.Name='' then Halt(102);
        return:=4;
        diVor:=diLast;
      end;
    end;
  end;

  { Zeile mit nchster Datei zusammenstellen: }
  Zeile:=DispZeile(diVor);
  Writeln(Zeile);

  { Neuen Dateinamen in File schreiben }
  Datei:=DiVor.Name;
  Assign(f,GetEnv('NAMEFILE'));
  Rewrite(f);
    Writeln(f,Datei);
  Close(f);

  Halt(return);
end.