; ************************************************************************
; ************* PRINTCHR Gibt Strings und ASCII-Zeichen aus             **
; ************* (C) 2001-12-15 by Klaus Peichl                          **
; *************                   Dornbergstr. 10                       **
; *************                   91058 Erlangen-Tennenlohe             **
; *************                   (pei@freenet.de)                      **
; ************************************************************************

                .MODEL tiny
                .Code
                .386
                ORG 100h


; ************************************************************************
; ************* Hauptprogramm                                           **
; ************************************************************************


Start:          push ds
                pop  es

                mov si,80h
                cld
                lodsb
                mov cl,al               ; Lnge der Kommandozeilenparameter
                cmp cl,1
                ja ParamOk
                mov dx,Offset SyntaxStr
                mov ah,9
                int 21h
                jmp Ende
ParamOk:        lodsb                   ; Erstes Leerzeichen berlesen

GetChar:        dec cl
                jz Ende
                lodsb
CheckChar:      cmp al,' '
                jb Ende
                cmp al,'#'
                je GetZahl              ; Kommt eine Ziffernfolge?
                mov dl,al               ; nein, normales ASCII-Zeichen
                jmp PrintChar

GetZahl:        mov dl,0                ; Zahl entsteht in dl
  GetZiffer:    lodsb
                sub al,'0'
                cmp al,9
                jbe ZifferOk
                dec si
                jmp ZahlFertig
  ZifferOk:     mov dh,al
                mov al,10
                mul dl
                add al,dh
                mov dl,al
                cmp dl,26               ; nach "26" wird keine Ziffer
                jb GetZiffer            ; mehr erwartet (ASCII mu < 256 sein)
  ZahlFertig:
PrintChar:      mov ah,2
                int 21h
                jmp GetChar

Ende:           mov ah,4ch
                int 21h


; ************************************************************************
; ************* Konstanten und initialisierte Variablen                 **
; ************************************************************************

SyntaxStr       DB 'PrintChr (c) 2001-12-15 by Klaus Peichl',10,10,13
                DB 'Syntax:     PRINTCHR <String>',10,10,13
                DB 'This utility program prints out the string given on the command line.',10,13
                DB 'Special characters can be specified by a #-sign followed by the desired',10,13
                DB 'ASCII-code as a decimal number.',10,10,13
                DB 'Examples:   PRINTCHR #67:\          =>  "C:\"',10,13
                DB '            PRINTCHR Caution! #007  =>  "Caution!" + Beep',10,13
CR              DB 10,13,'$'


                END Start

