; **********************************************************************
; ************* REBOOT Startet den PC neu                             **
; ************* (C) 2001-04-20 by Klaus Peichl                        **
; *************                   Dornbergstr. 10                     **
; *************                   91058 Erlangen-Tennenlohe           **
; *************                   (pei@freenet.de)                    **
; **********************************************************************

		.Model tiny
		.Code
		Org 100h


; **********************************************************************
; ************* Hauptprogramm                                         **
; **********************************************************************

Start:          cmp sp,Offset Stapelend
                ja  StapelOk
                mov dx,Offset NoMemStr
                mov ah,9
                int 21h
                jmp Ende

StapelOk:       push ds
		pop es
		cld
                mov bx,1                ; Flag "Reset verhindern"

; ************* Parameter auswerten ************************************

		mov si,81h
CmdLineLoop:    lodsb
                cmp al,13
                jbe ParamEnd
		cmp al,' '
		je CmdLineLoop

                cmp al,'/'
                jne ParamEnd
                lodsb
		and al,255-32           ; Klein -> Grobuchstabe
                cmp al,'Q'              ; <Q>ick-Boot
                jne n_Q
                mov bx,1234h            ; Code fr Schnellstart
                jmp CmdLineLoop
  n_Q:          cmp al,'N'              ; <N>ormal-Boot
                jne n_C
                mov bx,0                ; Code fr normalen Start
                jmp CmdLineLoop
  n_C:          mov bx,1
                jmp CmdLineLoop


ParamEnd:       cmp bx,1
                je Info

                mov ah,0Dh
                int 21h                 ; Alle Dateien flushen

                mov ax,0040h
                mov es,ax
                mov [es:0072h],bx
                DB 0EAh, 0F0h, 0FFh, 0, 0F0h ; jmp 0F000h:0FFF0h

Info:           mov dx,Offset SyntaxStr
                mov ah,9
                int 21h

Ende:           mov ax,004ch
                int 21h


; ************************************************************************
; ************* Konstanten und Variablen                                **
; ************************************************************************

SyntaxStr       DB 'REBOOT   (c) 2001,2002 by Klaus Peichl',10,10,13

                DB 'Achtung: Dieses Programm startet den PC sofort neu.',10,13
                DB '         Bitte alle wichtigen Daten vorher speichern!',10,10,13

                DB 'Caution: This tool reboots the PC immediately.',10,13
                DB '         Make shure that all important data is saved!',10,10,13

                DB 'Syntax:  REBOOT /N    Normal startup process',10,13
                DB '         REBOOT /Q    Quick-Boot: Skip memory test',10,13,'$'

NoMemStr        DB '?OUT OF MEMORY  ERROR',10,13,'$'
Stapel          DB 100 Dup (?)
StapelEnd       DB ?
		END Start
