; ************************************************************************
; ************* SETERROR Setzt Errorlevel auf den gewnschten Wert      **
; ************* (C) 1999-04-07 by Klaus Peichl                          **
; *************                   Dornbergstr. 10                       **
; *************                   91058 Erlangen-Tennenlohe             **
; *************                   (pei@freenet.de)                      **
; ************************************************************************

                .MODEL tiny
                .Code
                .386
                ORG 100h


; ************************************************************************
; ************* Hauptprogramm                                           **
; ************************************************************************


Start:          push ds
                pop  es

                mov si,81h
                mov cx,10
                mov bh,0
                cld

GetChar:        lodsb
CheckChar:      cmp al,'0'
                jb Trennzeichen

                sub al,'0'
                mov bl,al
                mov ax,Zahl

                mul cx
                add ax,bx
                mov Zahl,ax
                jmp GetChar

Trennzeichen:   mov dx,Zahl
                mov Zahl,0

                cmp lastTZ,'-'
                jne n_Minus
                neg dx
  n_Minus:
                cmp lastTZ,'+'
                jne n_Plus
  n_Plus:

MakeSum:        mov lastTZ,al
                mov ah,ParamCount
                cmp ah,1
                jne n_Param1
                add Result,dx
  n_Param1:    
                cmp ah,2
                jne n_Param2
                add Min,dx
  n_Param2:    
                cmp ah,3
                jne n_Param3
                add Max,dx
  n_Param3:

                cmp al,13
                jbe ParamEnde

                cmp al,' '
                jne n_Space
                inc ParamCount

  Space:        lodsb
                cmp al,' '
                je Space
                jmp CheckChar

  n_Space:      jmp GetChar

ParamEnde:
                cmp ParamCount,1
                jae ok
                mov dx,Offset SyntaxStr
                mov ah,9
                int 21h
                jmp Ende

Ok:             mov ax,Result
                cmp ax,Min
                jge n_low
                mov ax,Max
  n_low:        cmp ParamCount,3        ; Maximum vorgegeben?
                jb  inRange
                cmp ax,Max
                jle inRange
                mov ax,Min

inRange:
Ende:           mov ah,4ch
                int 21h


; ************************************************************************
; ************* Konstanten und initialisierte Variablen                 **
; ************************************************************************

SyntaxStr       DB 'SetError (c) 1999-04-01 by Klaus Peichl',10,10,13
                DB 'Syntax:   SETERROR <Equation> [<Min> <Max>]',10,10,13
                DB 'This utility program is used to set ERRORLEVEL to a desired value.',10,13
                DB '<Equation> must be a sum of integers, the result must not be higher than 255.',10,13
                DB 'If <Equation> results in a number smaller than <Min>, it will be set to <Max>,',10,13
                DB 'if it results in a number bigger than <Max>, it will be set to <Min>.',10,10,13
                DB 'Examples:   SETERROR 10+1        =>  ERRORLEVEL==11',10,13
                DB '            SETERROR 10+2-3      =>  ERRORLEVEL==9 ',10,13
                DB '            SETERROR 10+5 1 14   =>  ERRORLEVEL==1 ',10,13
CR              DB 10,13,'$'
ParamCount      DB 0
Negativ         DB 0
Zahl            DW 0
Max             DW 0
Min             DW 0
Result          DW 0
lastTZ          DB 0


                END Start

