; ************************************************************************
; ************* SHUFFLE Zufallsgenerator fr Shuffle-Play               **
; ************* (C) 1999-04-09 by Klaus Peichl                          **
; *************                   Dornbergstr. 10                       **
; *************                   91058 Erlangen-Tennenlohe             **
; *************                   (pei@freenet.de)                      **
; ************************************************************************

		.Model tiny
		.Code
		Org 100h

; ------------------------------------------------------------------------
  INT21         MACRO
		LOCAL Ok
; ------------------------------------------------------------------------
		int 21h
		jnc Ok
		mov dx,Offset FileErrStr
		mov ah,9
		int 21h
		jmp Ende
	    ok: ENDM


; ************************************************************************
; ************* Hauptprogramm                                           **
; ************************************************************************

Start:          cmp sp,Offset Stapelend
                ja  StapelOk
                mov dx,Offset NoMemStr
                mov ah,9
                int 21h
                jmp Ende

StapelOk:       push ds
		pop es
		cld

; ************* Dateiname vorbereiten *********************************

		mov si,81h
Space:          lodsb
                cmp al,13
                jbe ParamEnd
		cmp al,' '
		je Space

		mov dx,si               ; Anfangspos. Dateiname
		dec dx
		mov NamePos,dx

ScanName:       lodsb
		cmp al,' '
		ja ScanName

		dec si
		mov Byte Ptr [si],0

ParamEnd:       cmp si,82h
                ja ParamOk
                mov dx,Offset SyntaxStr
                mov ah,9
                int 21h
                jmp Ende2
ParamOk:

; ************* Datei einlesen ****************************************

		mov ax,3D00h            ; Open File (read)
		INT21

OpenOk:         mov bx,ax               ; bx := Handle
		mov cx,2000
		mov dx,Offset Puffer1
		mov ax,3F00h            ; Daten einlesen
		INT21

		mov Bytes,ax

		mov ax,3E00h            ; Datei schlieen
		INT21
		

; ************* Zeilen zhlen und Whitespace rausfiltern **************

		mov cx,Bytes
                cmp cx,0
                je CountEnd
		mov si,Offset Puffer1
		mov di,Offset Puffer2

CountLines:     lodsb
		cmp al,13               
		jbe Trennzeichen
  Count2:       cmp al,'0'
		jb n_Ziffer
		stosb
  n_Ziffer:     loop Countlines
		jmp CountEnd

Trennzeichen:   mov al,13               ; CR benehmen
		stosb
		inc Lines
  TZ_Loop:      lodsb
		dec cx
		jz CountEnd
		cmp al,13               ; noch ein Trennzeichen?
		ja  Count2
		jmp TZ_Loop

CountEnd:       sub di,Offset Puffer2
		mov Bytes,di
		cmp Lines,0
		jne LinesOk
		mov Zahl,0
		jmp Ende2
LinesOk:


; ************* Zufallszahl ermitteln *********************************

		mov ah,0
		int 1Ah                 ; Timer-Ticks lesen (CX|DX)
                xor dl,dh               ; dl=Zufallszahl (0..255)

		; Maske generieren, die alle Bits lscht, die hher als
		; die Zeilenzahl sind.
		mov ax,1
MakeMask:       cmp ax,Lines
		jae MaskOk
		stc
		rcl ax,1
		jmp MakeMask
MaskOk:         and dx,ax               ; dl=Zufallszahl (0..Lines)
		cmp dx,Lines
		jb  ZufallOk
                xor dx,ax

ZufallOk:       inc dx
		mov Zufall,dx

;              mov ax,zufall
;              call printhexword


; ************* Zeile unterdrcken ************************************

		mov si,Offset Puffer2
		mov di,Offset Puffer1
		mov cx,Lines

FilterLoop:
		cmp cx,Zufall
		je  FetchNumber

		lodsb
  Copy:         stosb
		cmp al,13
		jne FilterLoop
		mov al,10
		stosb
		loop FilterLoop
		jmp Write

FetchNumber:    dec cx
		xor ax,ax
  NumLoop:      lodsb
		mov dl,al
		sub dl,'0'
		cmp dl,9
		ja ZahlEnde
  Ziffer:       mov dh,10
                mov ax,Zahl
		mul dh
		mov dh,0
		add ax,dx
		mov Zahl,ax
		jmp NumLoop

  ZahlEnde:     cmp cx,0
                jz Write
                jmp FilterLoop

; ************* Datei neu schreiben ***********************************
Write:


;                mov dx,NamePos
;                mov ah,41h
;                int 21h ; del

		mov dx,NamePos

		mov ax,3C00h            ; Create File
		INT21

		mov bx,ax               ; Handle

		mov cx,di
		mov dx,Offset Puffer1
		sub cx,dx               ; neue Lnge ermitteln

		mov ax,4000h
		INT21

Ende:           mov ax,3E00h            ; Datei schlieen
		INT21

Ende2:          mov ax,Zahl
		mov ah,4ch
		int 21h


; ************************************************************************
; ************* Konstanten und Variablen                                **
; ************************************************************************

SyntaxStr       DB 'SHUFFLE  (c) 1999-04-09, 2000-05-04 by Klaus Peichl',10,10,13
                DB 'This tool removes a randomly chosen line from the given file and returns',10,13
                DB 'the number on that line as Errorlevel.',10,13
                DB 'The file must not have more than 255 lines and the contained numbers must',10,13
                DB 'not be bigger than 255. Any white space in the file will also be removed.',10,10,13
		DB 'Syntax:  SHUFFLE <Filename>',10,13,'$'
NoMemStr        DB '?OUT OF MEMORY  ERROR',10,13,'$'
FileErrStr      DB 'SHUFFLE Fatal: File I/O Error!',10,13,'$'
Lines           DW 0
Zahl            DW 0
Bytes           DW ?
Zufall          DW ?
NamePos         DW ?
Puffer1         DB 2002 Dup (?)
Puffer2         DB 2002 Dup (?)
Stapel          DB 500 Dup (?)
StapelEnd       DB ?
		END Start
