Program ShufName;
uses Dos;

{ Hilfsprogramm fr MPEG-CD-Player.
  Liest den Inhalt von <DirFile> und whlt zufllig eine Zeile aus.

  (C) 26.07.1998 by Klaus Peichl, stl. Ringstr. 7, 85113 Bhmfeld
                    E-mail: kspeichl@cip.e-technik.uni-erlangen.de
  Rechner:  IBM-kompatibler PC
  Compiler: Borland Turbo-Pascal 6.0                               }

Var f1, f2                     : text;
    Pfad,Datei,Zeile,s         : String;
    DirFile,PfadFile,DateiFile,TmpFile : String;
    i, Nummer, Anz, Code       : Integer;
    Info                       : boolean;
    Switch                     : Char;

Function GetEnvVar(EnvVar:string):string;
Var s:String;
Begin
  s:=GetEnv(EnvVar);
  if s='' then begin
    writeln('Environment variable ',EnvVar,' must be set!');
    Halt(100);
  end;
  GetEnvVar:=s;
end;


Begin
  If ParamCount=0 then begin
    Writeln('ShufName (c) 1998-07-26 / 1999-06-10 by Klaus Peichl');
    writeln('Syntax:  SHUFNAME <DirFile> [/T#] [/I]');
    writeln;
    writeln('This tool rewrites two files which names are given by the environment');
    writeln('variables PATHFILE and NAMEFILE.');
    writeln('<DirFile> contains a list of files that can be generated with the DOS');
    writeln('command "DIR /S /B *.MP3".');
    writeln('ShufName deletes a randomly chosen line from <DirFile> and evaluates');
    writeln('the filename on that line. Its path will be saved to <Pathfile> and');
    writeln('the actual filename will be saved to <NameFile>.');
    writeln;
    Writeln('Optional parameters: /T# = Force line number #');
    writeln('                      /I = Display some additional info');
    writeln;
    writeln('Return values:         0 = ok');
    writeln('                       1 = <DirFile> was empty');
    writeln('                       2 = Invalid lines in <DirFile>');
    writeln('                     100 = Environment variable not set');
    Halt(0);
  end;

  Pfad :=GetEnvVar('PATHFILE');
  Datei:=GetEnvVar('NAMEFILE');

  DirFile  :=ParamStr(1);
  PfadFile :=GetEnv('PATHFILE');
  DateiFile:=GetEnv('NAMEFILE');

  Nummer:=0;
  Info:=false;

  (* Parameterauswertung: *)

  i:=0;
  While i<ParamCount do begin
    inc(i);
    If Copy(ParamStr(i),1,1)='/' then begin
      s:=Copy(ParamStr(i),2,1);
      Switch:=Upcase(s[1]);
      If Switch='T' then begin
        Val(Copy(ParamStr(i),3,Length(ParamStr(i))-2),Nummer,Code);
        If Code<>0 then Nummer:=1; (* Zahl nicht erkannt *)
      end
      else Info:=true;
    end
    else DirFile:=ParamStr(i);
  end;


  (* Temporren Dateinamen festlegen: *)
  TmpFile  :=DirFile;
  i:=Pos('.',TmpFile);
  (* Eventuell vorhandene Extension abschneiden: *)
  if (i>0) and (i<=length(TmpFile)) then TmpFile:=Copy(TmpFile,1,i-1);
  TmpFile:=TmpFile+'.TMP';

  (* Variable Zeile per Zufall auswhlen: *)
  Assign(f1,DirFile);
  Anz:=0;
  Randomize;
  Reset(f1);
  While not EOF(f1) do begin
    Readln(f1,Zeile);
    inc(Anz);
  end;
  Close(f1);

  (* Falls DirFile leer war, gibt es keine MPEG-Titel *)
  If Anz=0 then Halt(1);

  If Nummer>Anz then Nummer:=Anz;
  If Nummer=0 then Nummer:=Random(Anz)+1;
  Reset(f1);
  Assign(f2,TmpFile); Rewrite(f2);
  For i:=1 to Anz do begin
    Readln(f1,s);
    If i<>Nummer then writeln(f2,s)
    else Zeile:=s;
  end;
  Close(f1);
  Close(f2);
  Erase(f1);
  Rename(f2,DirFile);

  (* Aus Zeile die Variablen Pfad und Datei extrahieren: *)
  i:=Length(Zeile);
  If i=0 then begin
    writeln('ShufName warning: Blank line in "',ParamStr(1),'"!');
    Halt(2);
  end;
  While (Zeile[i]<>'\') and (i>0) do dec(i);
  If i=0 then begin
    writeln('Fehler: Kein Backslash gefunden!');
    Halt(2);
  end;
  Pfad:=Copy(Zeile,1,i-1);
  Datei:=Copy(Zeile,i+1,length(Zeile)-i);

  (* Infos ausgeben, falls Parameter mit '/' bergeben wurde: *);
  If Info then begin
    Writeln('Zufallszahl: ',Nummer);
    Writeln('Pfad:        ',Pfad);
    Writeln('Datei:       ',Datei);
  end;

  (* Die Dateien <Pathfile> und <Namefile> aktualisieren: *)
  Assign(f1,PfadFile);
  Rewrite(f1);
    Writeln(f1,Pfad);
  Close(f1);
  Assign(f1,DateiFile);
  Rewrite(f1);
    Writeln(f1,Datei);
  Close(f1);
end.